// MLP101CDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MLP101C.h"
#include "MLP101CDlg.h"
#include "MLP101CUSBHIDIO.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CUSBHIDIO CUsb;

unsigned int time_elapse, sec, min, hour;
float mas;


CHIDIOWINCDlg::CHIDIOWINCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHIDIOWINCDlg::IDD, pParent)
  , m_EditVoltage(_T(""))
  , m_StaticVoltage(_T(""))
  , m_Static_Current(_T(""))
  , m_StaticLoopV(_T(""))
  , m_EditC1(_T(""))
  , m_EditC2(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHIDIOWINCDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_STATIC_ERROR, c_Error);
  DDX_Text(pDX, IDC_EDIT1_VOLTAGE, m_EditVoltage);
  DDX_Text(pDX, IDC_STATIC_VOLTAGE, m_StaticVoltage);
  DDX_Text(pDX, IDC_STATIC_CURRENT, m_Static_Current);
  DDX_Text(pDX, IDC_EDIT2_C1, m_EditC1);
  DDX_Text(pDX, IDC_EDIT3_C2, m_EditC2);
}

BEGIN_MESSAGE_MAP(CHIDIOWINCDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(ID_BUTTON_OPEN, &CHIDIOWINCDlg::OnBnClickedButtonOpen)
	ON_WM_DESTROY()
	ON_WM_TIMER()
  ON_BN_CLICKED(IDC_BUTTON1_VSET, &CHIDIOWINCDlg::OnClickedButton1Vset)
  ON_BN_CLICKED(IDC_BUTTON2_ON, &CHIDIOWINCDlg::OnBnClickedButton2On)
  ON_BN_CLICKED(IDC_BUTTON1_OFF, &CHIDIOWINCDlg::OnBnClickedButton1Off)
  ON_BN_CLICKED(IDC_BUTTON1, &CHIDIOWINCDlg::OnBnClickedButton1)
  ON_BN_CLICKED(IDC_BUTTON2, &CHIDIOWINCDlg::OnBnClickedButton2)
END_MESSAGE_MAP()


// CHIDIOWINCDlg message handlers

BOOL CHIDIOWINCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHIDIOWINCDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHIDIOWINCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}




// Opens or closed the device
void CHIDIOWINCDlg::OnBnClickedButtonOpen()
{
	//GetDlgItem(IDC_STATIC_ERROR)->SetWindowTextA("");	// clear the error window
  c_Error.SetWindowTextA("");

	if(CUsb.IsOpen()) {		// if device is open, then close it
    Tbuffer[0] = 0x12;
    if (CUsb.WriteCmd(Tbuffer, 8))
      TRACE("error\n");

		KillTimer(ID_MAIN_TIMER); 
		CUsb.CloseDevice();
		GetDlgItem(ID_BUTTON_OPEN)->SetWindowTextA("Open");
		GetDlgItem(IDC_STATIC_DEVICE)->SetWindowTextA("Device Status: Offline.");
    GetDlgItem(IDC_EDIT1_VOLTAGE)->EnableWindow(FALSE);
    GetDlgItem(IDC_BUTTON1_VSET)->EnableWindow(FALSE);
    GetDlgItem(IDC_BUTTON2_ON)->EnableWindow(FALSE);
    GetDlgItem(IDC_BUTTON1_OFF)->EnableWindow(FALSE);
    GetDlgItem(IDC_BUTTON1)->EnableWindow(FALSE);
    GetDlgItem(IDC_BUTTON2)->EnableWindow(FALSE);
    m_StaticVoltage = "";
    m_Static_Current = "";
    UpdateData(FALSE);
		}
	else {					// else try and open it
		CUsb.OpenDevice();
		if(CUsb.IsOpen()) {
			GetDlgItem(ID_BUTTON_OPEN)->SetWindowTextA("Close");
			GetDlgItem(IDC_STATIC_ERROR)->SetWindowTextA(""); // Clear warnings
			GetDlgItem(IDC_STATIC_DEVICE)->SetWindowTextA("Device Status: Online.");
      GetDlgItem(IDC_EDIT1_VOLTAGE)->EnableWindow(TRUE);
      GetDlgItem(IDC_BUTTON1_VSET)->EnableWindow(TRUE);
      GetDlgItem(IDC_BUTTON2_ON)->EnableWindow(TRUE);
      GetDlgItem(IDC_BUTTON1)->EnableWindow(TRUE);
      GetDlgItem(IDC_BUTTON2)->EnableWindow(TRUE);
      
			MPULABDeviceInfoStruct Info;
			if(CUsb.GetDeviceInfo(&Info)) {
				GetDlgItem(IDC_STATIC_ERROR)->SetWindowTextA("Warning: Failed to read device infomation!");
				return;
				}
			

			// Read Device family, product, Version & Serial Number

			sprintf(str,"Device Status: Online.\nsn1:%x sn2:%x sn3:%x pname:%s",
					Info.serial1, Info.serial2, Info.serial3, Info.pname);
			GetDlgItem(IDC_STATIC_DEVICE)->SetWindowTextA(str);

      
			// Enable timer
			SetTimer(ID_MAIN_TIMER, TIMER_PERIOD, 0 ); 
			}
		else {
			GetDlgItem(IDC_STATIC_ERROR)->SetWindowTextA("Warning: Unable to open device.");
			GetDlgItem(IDC_STATIC_DEVICE)->SetWindowTextA("Device Status: Offline.");
			
			}

	}
	
}

// -----------------------------------------------------//
// Called when the dialog is about to be destoryed
// -----------------------------------------------------//
void CHIDIOWINCDlg::OnDestroy()
{
  if (CUsb.IsOpen())
  {
    Tbuffer[0] = 0x12;
    if (CUsb.WriteCmd(Tbuffer, 8))
      TRACE("error\n");
  }
  CDialog::OnDestroy();
	CUsb.CloseDevice();

}


// -----------------------------------------------------//
// Checkif Open Open, if closed display warning
// -----------------------------------------------------//
int CHIDIOWINCDlg::CheckIfOpen(void)
{
	GetDlgItem(IDC_STATIC_ERROR)->SetWindowTextA("");		// always clear the error window
	if(CUsb.IsOpen()) return(1);
	// else device closed
	GetDlgItem(IDC_STATIC_ERROR)->SetWindowTextA("Warning: Device not currently opened!");

	return 0;
}

// -----------------------------------------------------//
// Update measurements
// -----------------------------------------------------//
int CHIDIOWINCDlg::UpdateCURRENT(void)
{
  if(!CUsb.IsOpen()) return(1);
	unsigned char buffer[64];
	if( CUsb.ReadPorts(buffer))	{
		GetDlgItem(IDC_STATIC_ERROR)->SetWindowTextA("Warning: Failed to read information");
  
    //c_Error.SetWindowTextA("Warning: Failed to read DIPSW!");
		KillTimer(ID_MAIN_TIMER); 
		return 1;
		}

  //TRACE("test%x %x %x\n", buffer[0], buffer[1], buffer[2]);
  //TRACE("v %2.2f \n", *(unsigned short *)&buffer[0] / 100);
  m_StaticVoltage.Format("%2.2f", *(unsigned short *)&buffer[0] / 100.);
  m_Static_Current.Format("%1.3f", *(unsigned short *)&buffer[2] / 1000.);
  SetDlgItemText(IDC_STATIC_VOLTAGE, m_StaticVoltage);
  SetDlgItemText(IDC_STATIC_CURRENT, m_Static_Current);
  
  time_elapse = *(unsigned int *)&buffer[6];
  hour = time_elapse / 3600;
  time_elapse = time_elapse - (hour * 3600);
  min = time_elapse / 60;
  time_elapse = time_elapse - (min * 60);
  sec = time_elapse;
  sprintf(str, "%04dh %02dm %02ds", hour, min, sec);
  GetDlgItem(IDC_STATIC_ETIME)->SetWindowTextA(str);
  sprintf(str, "%2.5f", (*(unsigned short *)&buffer[0] / 100.) * (*(unsigned short *)&buffer[2] / 1000.));
  GetDlgItem(IDC_STATIC_POWER)->SetWindowTextA(str);
  //mas = mas + (*(unsigned short *)&buffer[2] * (0.1 / 3600));
  mas = *(float *)&buffer[10];
  sprintf(str, "%4.4f", mas);
  GetDlgItem(IDC_STATIC_mAh)->SetWindowTextA(str);
  //if (*(unsigned short *)&buffer[2] > 2000)
  if (*(unsigned short *)&buffer[14])
  {
    Tbuffer[0] = 0x12;
    if (CUsb.WriteCmd(Tbuffer, 8))
      TRACE("error\n");
    Tbuffer[0] = 0x13;
    if (CUsb.WriteCmd(Tbuffer, 8))
      TRACE("error\n");
    GetDlgItem(IDC_BUTTON2_ON)->EnableWindow(TRUE);
    GetDlgItem(IDC_BUTTON1_OFF)->EnableWindow(FALSE);
    MessageBox("Current Limit", "Error");
  }

	return 0;
}


// -----------------------------------------------------//
// Our timer event
// -----------------------------------------------------//
void CHIDIOWINCDlg::OnTimer(UINT_PTR nIDEvent)
{
	UpdateCURRENT();

	CDialog::OnTimer(nIDEvent);
}


void CHIDIOWINCDlg::OnClickedButton1Vset()
{
  // TODO: Add your control notification handler code here
  unsigned short i;
  float f;
  if (CUsb.IsOpen())
  {
    UpdateData(TRUE);
    TRACE("string%s\n", m_EditVoltage);
    sscanf(m_EditVoltage, "%f", &f);
    TRACE("f:%2.2f\n", f);
    i = (unsigned short)(f * 100);
    TRACE("i:%d\n", i);
    if ((i > 2000) || (f < 0) || (f > 20))
    {
      MessageBox("Invalid Value", "Error");
      m_EditVoltage = "";
      UpdateData(FALSE);
    }
    else
    {
      Tbuffer[0] = 0x10;
      *(unsigned short *)&Tbuffer[1] = i;
      if (CUsb.WriteCmd(Tbuffer, 8))
        TRACE("error\n");
      //m_StaticVoltage.Format("%2.2f", f);
      //UpdateData(FALSE);
    }
  }
}


void CHIDIOWINCDlg::OnBnClickedButton2On()
{
  // TODO: Add your control notification handler code here
  if (CUsb.IsOpen())
  {
    Tbuffer[0] = 0x11;
    if (CUsb.WriteCmd(Tbuffer, 8))
      TRACE("error\n");
    GetDlgItem(IDC_BUTTON2_ON)->EnableWindow(FALSE);
    GetDlgItem(IDC_BUTTON1_OFF)->EnableWindow(TRUE);
    sec = min = hour = 0;
    mas = 0;
  }
}


void CHIDIOWINCDlg::OnBnClickedButton1Off()
{
  // TODO: Add your control notification handler code here
  if (CUsb.IsOpen())
  {
    Tbuffer[0] = 0x12;
    if (CUsb.WriteCmd(Tbuffer, 8))
      TRACE("error\n");
    GetDlgItem(IDC_BUTTON2_ON)->EnableWindow(TRUE);
    GetDlgItem(IDC_BUTTON1_OFF)->EnableWindow(FALSE);
  }
}


void CHIDIOWINCDlg::OnBnClickedButton1()
{
  // TODO: Add your control notification handler code here
  unsigned int i;
  float f, f2, fresult;
  unsigned char *ftemp;
  if (CUsb.IsOpen())
  {
    UpdateData(TRUE);
    TRACE("string%s\n", m_EditC1);
    sscanf(m_EditC1, "%f", &f);
    sscanf(m_EditC2, "%f", &f2);
    fresult = f / f2;
    TRACE("f:%1.4f\n", fresult);
    if ((fresult > 1.1) || (fresult < 0.9))
    {
      MessageBox("Invalid Value", "Error");
      m_EditC1 = "";
      m_EditC2 = "";
      UpdateData(FALSE);
    }
    else
    {
      Tbuffer[0] = 0x20;
      i = (unsigned int)f;
      ftemp = (unsigned char *)&fresult;
      Tbuffer[1] = *ftemp++;
      Tbuffer[2] = *ftemp++;
      Tbuffer[3] = *ftemp++;
      Tbuffer[4] = *ftemp;
      
      if (CUsb.WriteCmd(Tbuffer, 8))
        TRACE("error\n");

    }
  }
}


void CHIDIOWINCDlg::OnBnClickedButton2()
{
  // TODO: Add your control notification handler code here
  float fresult;
  unsigned char *ftemp;
  if (CUsb.IsOpen())
  {
      Tbuffer[0] = 0x20;
      fresult = 1.0;
      ftemp = (unsigned char *)&fresult;
      Tbuffer[1] = *ftemp++;
      Tbuffer[2] = *ftemp++;
      Tbuffer[3] = *ftemp++;
      Tbuffer[4] = *ftemp;

      if (CUsb.WriteCmd(Tbuffer, 8))
        TRACE("error\n");

  }
}
