// MLP101CUSBHIDIO.h : header file


#pragma once

// The following constants determine which HID device to find and connect to.
#define USB_VID 0x0448		// USB Vendor ID 
#define USB_PID 0x3b91		// USB Product ID


// DataStruct used by the GetDeviceInfo functions
typedef struct MPULABDeviceInfoStruct_ {
		unsigned short int family;
		unsigned short int product;
		unsigned short int version;
    unsigned int serial1;
    unsigned int serial2;
    unsigned int serial3;
    unsigned char pname[24];
		unsigned int reserved1;
    unsigned int reserved2;
		} MPULABDeviceInfoStruct, *pMPULABDeviceInfoStruct;



// THE USBHIDIO class
class CUSBHIDIO
{
	protected:
		HANDLE hDevice; // Handle to the device, zero if not openned
		unsigned char DeviceName[512];
    unsigned char rpacket[128];
    unsigned char wpacket[128];

	public:
	
		CUSBHIDIO();			// Construction
		unsigned int CloseDevice(void);
		unsigned int OpenDevice(void);
		unsigned int ScanForHIDDevice(unsigned int VID, unsigned int PID);
		


public:
	// // Return ture if the device is currently openned
	int IsOpen(void);
  int WriteCmd(unsigned char *pbuffer, unsigned int Length);
	int CUSBHIDIO::GetDeviceInfo(pMPULABDeviceInfoStruct pInfo);
  int ReadPorts(unsigned char *pbuffer);
};


